{-# OPTIONS -fglasgow-exts #-}
{-# OPTIONS -fallow-undecidable-instances #-}
{-# OPTIONS -fallow-overlapping-instances #-}
{-# OPTIONS -fth #-}
{-# OPTIONS -fgenerics #-}
module Lam where

import NominalBase
import NominalAbs
import NominalSubst
import Data.RepLib

data Lam = Var Name
	 | App Lam Lam
	 | Lam (Abs Name Name Lam)  deriving Show

$(derive [''Lam])


instance Eq Lam where
    (==) = aeq (undefined :: Proxy Name)

instance HasVar Name Lam where
    is_var (Var x) = Just x
    is_var y = Nothing
    var x = Var x


nx = (Name "x" Nothing) 

main = do print $ evalFM (subst
			  nx 
			  (App (Var (Name "w" Nothing)) (Var (Name "z" Nothing))) 
			  (App (Var (Name "x" Nothing)) (Var (Name "y" Nothing))))

